// AboutPage.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "Fox.h"
#include "AboutPage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutPage _CAO


CAboutPage::CAboutPage(CWnd* pParent /*=NULL*/)
	: CDialog(CAboutPage::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAboutPage)
	m_cInfo = _T("");
	//}}AFX_DATA_INIT
	m_cInfo = "hilo-m@mb.nma.ne.jp\r\nhttp://www.mb.nma.ne.jp/~hilo-m/";
}


void CAboutPage::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutPage)
	DDX_Control(pDX, IDC_DllInfoEdit, m_cnDllInfo);
	DDX_Control(pDX, IDC_VersionList, m_cnList);
	DDX_Text(pDX, IDC_InfoEdit, m_cInfo);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAboutPage, CDialog)
	//{{AFX_MSG_MAP(CAboutPage)
	ON_NOTIFY(NM_CLICK, IDC_VersionList, OnClickVersionList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAboutPage bZ[W nh

/*----------------------------------------------------------------------------*/
//  T  vF  [hɌĂ
//    F  void
//  ߂lF  void
//    lF  KAĂłB
/*----------------------------------------------------------------------------*/
void CAboutPage::Load()
{
	/* Xgr[̏ */
	// sIɂ
	m_cnList.SetExtendedStyle(LVS_EX_FULLROWSELECT);	

	// s̒ǉ
	int i = 0;
	m_cnList.InsertColumn( i++ , "Name", LVCFMT_LEFT , 100 , -1);
	m_cnList.InsertColumn( i++ , "Ver", LVCFMT_LEFT , 50 , -1);

	// eDLL̃o[Wǉ
	SetVersion("UNZIP32.DLL",UnzipGetVersion());
	SetVersion("ZIP32J.DLL",ZipGetVersion());
	IsDll("ZIP32.DLL");
}

/*----------------------------------------------------------------------------*/
//  T  vF  Unzip32.dll̃o[W擾
//    F  Ȃ
//  ߂lF  o[W * 100
//    lF  void
/*----------------------------------------------------------------------------*/
WORD CAboutPage::UnzipGetVersion()
{
	HINSTANCE hLib = ::LoadLibrary("Unzip32.dll");
	typedef WORD (GetVersion)(VOID);

	if(hLib == NULL){return -1;}
	GetVersion *pGetVersion = (GetVersion*)::GetProcAddress(hLib ,"UnZipGetVersion");

	int nVersion = 0;
	nVersion = pGetVersion();
	::FreeLibrary(hLib);

	return nVersion;
}

/*----------------------------------------------------------------------------*/
//  T  vF  DLL̃o[W\
//    F  DLL̖O , o[W*100
//  ߂lF  :0
//    lF  voif
/*----------------------------------------------------------------------------*/
int CAboutPage::SetVersion(LPCTSTR lpName, int nVersion)
{
	CString cVersion;

	cVersion.Format("v.%.2f",(double)nVersion / 100);

	int nIndex = m_cnList.InsertItem(0,lpName,NULL);
	m_cnList.SetItem(nIndex , 1 , LVIF_TEXT , cVersion , 0 ,0 , 0 ,0);
	return 0;
}

/*----------------------------------------------------------------------------*/
//  T  vF  Zip32j.dll̃o[W擾
//    F  Ȃ
//  ߂lF  o[W * 100
//    lF  void
/*----------------------------------------------------------------------------*/
WORD CAboutPage::ZipGetVersion()
{
	HINSTANCE hLib = ::LoadLibrary("Zip32j.dll");
	typedef WORD (GetVersion)(VOID);

	if(hLib == NULL){return -1;}
	GetVersion *pGetVersion = (GetVersion*)::GetProcAddress(hLib ,"ZipGetVersion");

	int nVersion = 0;
	nVersion = pGetVersion();
	::FreeLibrary(hLib);

	return nVersion;
}

/*----------------------------------------------------------------------------*/
//  T  vF  DLLĂ邩ׂ
//    F  DLL̖O
//  ߂lF  0
//    lF  Ȃ
/*----------------------------------------------------------------------------*/
int CAboutPage::IsDll(LPCTSTR lpDll)
{
	HINSTANCE hLib = ::LoadLibrary(lpDll);

	LPCTSTR lpState;

	if(hLib != NULL)
	{
		lpState = "";
	}else{
		lpState = "";
	}

	// Xgr[ɒǉ
	int nIndex = m_cnList.InsertItem(0,lpDll,NULL);
	m_cnList.SetItem(nIndex , 1 , LVIF_TEXT , lpState , 0 ,0 , 0 ,0);

	::FreeLibrary(hLib);
	return 0;
}


/*----------------------------------------------------------------------------*/
//  T  vF  IꂽDLL̏\
//    F  
//  ߂lF  void
//    lF nh֐
/*----------------------------------------------------------------------------*/
void CAboutPage::OnClickVersionList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CString cName;
	int nIndex;
	
	nIndex = m_cnList.GetSelectionMark();
	cName = m_cnList.GetItemText(nIndex , 0);
	
	// DLLƂ̏
	/*
	uҁv
	uprv
	uz[y[Wv
	u[AhXv
	*/
	CString cInfo;
	if(cName == "UNZIP32.DLL")
	{
		// UNZIP32.dll̏ꍇ
		cInfo = "(c)shoda T.\r\n"
				"ZIPɂ̉\r\n"
				"http://www.csdinc.co.jp/archiver/\r\n"
				"shoda@csdinc.co.jp";
	}
	else if(cName == "ZIP32J.DLL")
	{
		cInfo = "(c)g Pv\r\n"
				"ZIPɂ̈k\r\n"
				"http://openlab.ring.gr.jp/tsuneo/zip32j/\r\n"
				"tsuneo@rr.iij4u.or.jp";
	}
	else if(cName == "ZIP32.DLL")
	{
		cInfo = "(c)Info-ZIP\r\n"
				"ZIPɂ̈k\r\n"
				"http://www.info-zip.org/pub/infozip/";
	}

					

	// \
	m_cnDllInfo.SetWindowText(cInfo);
	*pResult = 0;
}
