// Encode.cpp: CEncode NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Fox.h"
#include "Encode.h"

#include "FileApi.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#define MAX_BUFFER 32767
#define ARCHIVE_FILE _T("_pass.zip")
//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CEncode::CEncode()
{
	// Ce[^̏
	m_itFile = m_liFile.begin();
}

CEncode::~CEncode()
{
	// eDLL̉
	::FreeLibrary(m_hZipLib);
	::FreeLibrary(m_hUnzipLib);
}

/*----------------------------------------------------------------------------*/
//  T  vF  tH_̃pXݒ肷
//    F  tH_̃pX
//  ߂lF   == 0
//    lF  void
/*----------------------------------------------------------------------------*/
int CEncode::SetPath(LPCTSTR lpPath)
{
	m_inMax = 0;
	// pX"C:\windows\"Ƃ`ɂB(Ōオ'\')
	CString cPath = lpPath;
	cPath.TrimRight("\\");
	cPath += "\\";
	
	m_cPath = cPath;
	// ́AtH_̃t@C擾
	CFileFind cFind;

	if(cFind.FindFile(cPath + "*") != 0)
	{
		int i = 1;

		while(i)
		{
			i = cFind.FindNextFile();

			if(cFind.IsDots()){ continue; }

			// t@CXgɒǉ
			m_liFile.push_front(cFind.GetFileName());
			m_inMax++;
		}

		return 0;
	}else{
		return -1;
	}
}

/*----------------------------------------------------------------------------*/
//  T  vF  tH_̃pX擾
//    F  void
//  ߂lF  tH_̃pX
//    lF  void
/*----------------------------------------------------------------------------*/
CString CEncode::GetPath()
{
	return m_cPath;
}

/*----------------------------------------------------------------------------*/
//  T  vF  t@CÍ
//    F  void
//  ߂lF   == 0
//    lF  void
/*----------------------------------------------------------------------------*/
int CEncode::Encode()
{
	// Zio32j.dllňk邽߂ɁAX|Xt@CɑSt@C
	CString cResponse;
	if(WriteResponse(cResponse) != 0)
	{
		AfxMessageBox(_T("X|Xt@Cւ݂̏Ɏs܂B"));
	}
	
	// R}hC
	CString cCmdLine , cOption , cFilePath , cDirectory;
	cOption = "-r -e";
	cFilePath = m_cPath + ARCHIVE_FILE;
	
	cCmdLine = cOption + _T(" \"") + cFilePath + _T("\" \"") + m_cPath + _T("\" \"@") 
				+ cResponse+ _T("\"") ;

	// ks
	if(Zip(cCmdLine) != 0)
	{
		::AfxMessageBox(_T("ZIPkɎs܂B"));
		return -1;
	}else{

		// t@C폜
		return FileDelete();
	}


}

/*----------------------------------------------------------------------------*/
//  T  vF  t@Ck
//    F  R}h
//  ߂lF  I == 0
//    lF  Zip32j.dll[h邾B
/*----------------------------------------------------------------------------*/
int CEncode::Zip(LPCTSTR lpCmdLine)
{
	if(m_hZipLib != NULL)
	{
		typedef  int(WINAPI ZIP)(const HWND , LPCTSTR , LPSTR , const DWORD);

		// ֐[h
		ZIP *pZip = (ZIP*)::GetProcAddress(m_hZipLib , "Zip");

		if(pZip == NULL){ return -1;}

		// ֐Ă
		char chBuffer[MAX_BUFFER + 1];
		return pZip(NULL , lpCmdLine , chBuffer , MAX_BUFFER);
	}else{
		return -1;
	}
}

/*----------------------------------------------------------------------------*/
//  T  vF  낢ȏ
//    F  void
//  ߂lF  void
//    lF  KĂԂ
/*----------------------------------------------------------------------------*/
void CEncode::Load()
{
	// eDLL[h
	m_hZipLib = ::LoadLibrary("Zip32j.dll");
	m_hUnzipLib = ::LoadLibrary("Unzip32.dll");
}

/*----------------------------------------------------------------------------*/
//  T  vF  X|Xt@CɃt@C̃Xg
//    F  void
//  ߂lF   == 0
//    lF  void
/*----------------------------------------------------------------------------*/
int CEncode::WriteResponse(CString &r_cResponse)
{
	// ꎞt@C̎擾
	CString cTempPath;
	CFileApi cFileApi;
	cTempPath = cFileApi.GetTempPath();

	// ꎞt@Cɏ
	CStdioFile cFile;

	if(cFile.Open(cTempPath , CFile::modeWrite) != 0)
	{
		for(m_itFile = m_liFile.begin() ; m_itFile != m_liFile.end() ; m_itFile++)
		{
			cFile.WriteString(*m_itFile + "\n");
		}

		m_liFile.erase(m_liFile.begin() , m_liFile.end());

		cFile.Close();
		r_cResponse = cTempPath;
		return 0;
	}else{
		return 1;
	}
}

/*----------------------------------------------------------------------------*/
//  T  vF  kƁAt@C폜
//    F  void
//  ߂lF   == 0
//    lF  void
/*----------------------------------------------------------------------------*/
int CEncode::FileDelete()
{
	CFileApi cFileApi;
	int nRes = 0;

	for(m_itFile = m_liFile.begin() ; m_itFile != m_liFile.end() ; m_itFile++)
	{
		nRes = cFileApi.Delete(m_cPath + *m_itFile);
	}

	return nRes;
}

/*----------------------------------------------------------------------------*/
//  T  vF  Unzip32.dllUnzip()Ăяo
//    F  R}hC
//  ߂lF  0@--- 
//    lF  DLL̓I[h
/*----------------------------------------------------------------------------*/
int CEncode::Unzip(LPCTSTR lpCmdLine)
{
	if(m_hUnzipLib != NULL)
	{
		typedef  int(WINAPI UNZIP)(const HWND , LPCTSTR , LPSTR , const DWORD);

		UNZIP* pUnzip = (UNZIP*)::GetProcAddress(m_hUnzipLib , _T("UnZip"));

		if(pUnzip == NULL){ AfxMessageBox(_T("API(Unzip)̃[hɎs܂B"));}

		// ֐Ă
		char chBuffer[MAX_BUFFER + 1];
		return pUnzip(NULL , lpCmdLine , chBuffer , MAX_BUFFER);
	}else{
		return -1;
	}
}

/*----------------------------------------------------------------------------*/
//  T  vF  tH_𕜍
//    F  void
//  ߂lF   == 0
//    lF  void
/*----------------------------------------------------------------------------*/
int CEncode::Decode()
{
	CString cCmdLine , cOption , cDirectory , cArchive;

	cOption = _T("-x");
	cArchive = _T("\"") + m_cPath + ARCHIVE_FILE +_T("\"");
	cDirectory = _T("\"") + m_cPath + _T("\"");

	cCmdLine = cOption + _T(" ") + cArchive + _T(" ") + cDirectory;

	int nRes = Unzip(cCmdLine);

	// t@C̍폜
	if(::DeleteFile(m_cPath + ARCHIVE_FILE) == 0)
	{
		::AfxMessageBox(ARCHIVE_FILE _T("̍폜Ɏs܂B"));
		DWORD dw = ::GetLastError();
	}
	return nRes;
}

/*----------------------------------------------------------------------------*/
//  T  vF  ÍĂ邩`FbN
//    F  pX
//  ߂lF  true / false
//    lF  void
/*----------------------------------------------------------------------------*/
int CEncode::IsDecode(LPCTSTR lpPath)
{
	CString cPath = lpPath;
	cPath += "\\"ARCHIVE_FILE;

	if(::GetFileAttributes(cPath) != 0xFFFFFFFF)
	{
		return TRUE;
	}else{
		return FALSE;
	}
}
