// Folder.cpp: CFolder NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Fox.h"
#include "Folder.h"

#include "SpecialFolder.h"
#include "FileString.h"
#include "FileApi.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CFolder::CFolder()
{
	m_pEncode = new CEncode;
	m_pEncode ->Load();
}

CFolder::~CFolder()
{
	delete m_pEncode;
}

/*----------------------------------------------------------------------------*/
//  T  vF  NX̏
//    F  void
//  ߂lF   -- 0
//    lF  ̂ƂA萔map̂
/*----------------------------------------------------------------------------*/
int CFolder::Load()
{
	LPCTSTR lpID;

	for(int i = 0 ; i < LAST ; i++)
	{

		switch(i)
		{
		case CONTROL:
			lpID = ID_CONTROL;
			break;
		case PRINTER:
			lpID =  ID_PRINTER;
			break;
		case TRASH:
			lpID =  ID_TRASH;
			break;
		case NETWORK:
			lpID =  ID_NETWORK;
			break;
		case DIAL_UP:
			lpID =  ID_DIAL_UP;
			break;
		case MY_COMPUTER:
			lpID =  ID_MY_COMPUTER;
			break;
		case FAVORITE:
			lpID =  ID_FAVORITE;
			break;
		case MY_DOCUMENT:
			lpID =  ID_MY_DOCUMENT;
			break;
		case CACHE:
			lpID =  ID_CACHE;
			break;
		case IE:
			lpID =  ID_IE;
			break;
		case ACTIVE_X:
			lpID =  ID_ACTIVE_X;
			break;
		case TASK:
			lpID = ID_TASK;
			break;
		case SUBSCRIPT:
			lpID = ID_SUBSCRIPT;
			break;
		case HISTORY:
			lpID = ID_HISTORY;
			break;
		
		default:
			return -1;
		}
		m_mSpecialFolder[i] = lpID;
	}
	return 0;
}

/*----------------------------------------------------------------------------*/
//  T  vF  NXID擾
//    F  萔
//  ߂lF  NXID
//    lF  ȂׂÅ֐g
/*----------------------------------------------------------------------------*/
LPCTSTR CFolder::GetID(int nIndex)
{
	return m_mSpecialFolder[nIndex];
}


/*----------------------------------------------------------------------------*/
//  T  vF  tH_U
//    F  tH_̃pX , 
//  ߂lF  VtH_̖O
//    lF  ̊֐͓݂̂ŌĂ΂
/*----------------------------------------------------------------------------*/
CString CFolder::Fake(LPCTSTR lpPath, int nType)
{
	CString cNewPath;

	cNewPath = lpPath;
	cNewPath += "." + m_mSpecialFolder[nType];

	if(rename(lpPath , cNewPath) != 0)
	{
		// s
		::AfxMessageBox(_T("l[Ɏs܂B"));
	}
	return (LPCTSTR)cNewPath;
}

/*----------------------------------------------------------------------------*/
//  T  vF  U
//    F  tH_̃pX , [h
//  ߂lF   --- 0
//    lF  void
/*----------------------------------------------------------------------------*/
int CFolder::Release(LPCTSTR lpPath,CString &r_cBuf, int nMode)
{
	CFileApi cFileApi;
	if(cFileApi.CheckDirectory(lpPath) == FALSE){ return F_FILE;}

	if(nMode == F_NORMAL || nMode == F_PASSWORD)
	{
		// ʏ@ł̋U
		if(m_pEncode ->IsDecode(lpPath) == TRUE)
		{
			// ÍĂ
			m_pEncode ->SetPath(lpPath);
			
			if(m_pEncode ->Decode() == 0)
			{
				r_cBuf = Release(lpPath);
			}else{
				return F_CANCEL;
			}
		}else{
			// ÍĂȂ
			r_cBuf = Release(lpPath);
		}
	}
	// FakeFolder 0.2x݊[h
	else if(nMode == F_COMPATIBLE)
	{
		r_cBuf = Release(lpPath);
	}

	// Uꂽ`FbN
	if(strcmp(lpPath , r_cBuf) == 0)
	{
		return F_SAMENAME;
	}
	else if(r_cBuf == "")
	{
		return F_ERROR;
	}else{
		return F_SUCUESS;
	}

}

/*----------------------------------------------------------------------------*/
//  T  vF  U
//    F  tH_̃pX
//  ߂lF  VtH_̃pX
//    lF  ݂̂s
/*----------------------------------------------------------------------------*/
CString CFolder::Release(LPCTSTR lpPath)
{
	// gq菜t@C擾
	CString cNewPath;
	CFileString cFStr;
	
	cNewPath = cFStr.CutExt(lpPath);

	if(rename(lpPath , cNewPath) == 0)
	{
		return cNewPath;
	}else{
		AfxMessageBox("l[Ɏs܂B");
		return "";
	}
}

/*----------------------------------------------------------------------------*/
//  T  vF  ÍsU
//    F  tH_̃pX , U
//  ߂lF   == 0
//    lF  ֐̂߂ǂ̂ŁAd`B(ro!C++
/*----------------------------------------------------------------------------*/
int CFolder::Fake(LPCTSTR lpPath, CString &r_cNewPath, int nType, int nMode)
{
	// tH_ǂ̃`FbN
	CFileApi cFileApi;
	BOOL bRes = cFileApi.CheckDirectory(lpPath);

	// t@CȂAG[
	if(bRes == FALSE){ return F_FILE;}

	/* Us */
	CString cBuf;

	/*if(nMode = F_NORMAL || nMode == F_COMPATIBLE)
	{
		cBuf = Fake(lpPath , nType);
		r_cNewPath = cBuf;
	}*/
	 
	if(nMode == F_PASSWORD)
	{
		// Í
		m_pEncode ->SetPath(lpPath);
		
		if(m_pEncode ->Encode() != 0)
		{
			return F_CANCEL;
		}
	}

	// ʂɋU
	cBuf = Fake(lpPath , nType);
	r_cNewPath = cBuf;
	

	return F_SUCUESS;
}
